﻿/**
 * rutor.org plugin for Movian Media Center
 *  Copyright (C) 2015 lprot
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

(function(plugin) {
    var logo = plugin.path + "logo.png";
    
    var blue = '6699CC', orange = 'FFA500', red = 'EE0000', green = '66ff72';

    function colorStr(str, color) {
        return '<font color="' + color + '"> (' + str + ')</font>';
    }

    function coloredStr(str, color) {
        return '<font color="' + color + '">' + str + '</font>';
    }

    function setPageHeader(page, title) {
        if (page.metadata) {
            page.metadata.title = title;
            page.metadata.logo = logo;
        }
        page.type = "directory";
        page.contents = "items";
        page.loading = false;
    }

    var service = plugin.createService(plugin.getDescriptor().title, plugin.getDescriptor().id + ":start", "video", true, logo);

    var settings = plugin.createSettings(plugin.getDescriptor().title, logo, plugin.getDescriptor().synopsis);

    settings.createString('baseURL', "Base URL without '/' at the end.", 'http://zerkalo-rutor.org', function(v) {
        service.baseURL = v;
    });

    function list(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
	var licon = plugin.path + "icon.png";
        var re = /<tr class="[gai|tum]+"><td>([\s\S]*?)<\/td>[\s\S]*?href="([\s\S]*?)"[\s\S]*?<a href[\s\S]*?<a href="([\s\S]*?)">([\s\S]*?)<\/a>([\s\S]*?)<\/tr>/g;
        var match = re.exec(doc);
        while (match) {
            if (match[5].match(/alt="C"/)) {
                var end = match[5].match(/[\s\S]*?<td align="right">[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
                var comments = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)</)[1];
            } else
                var end = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
            var url = service.baseURL + match[3];
            if (match[3].match(/http:\/\//))
                url = match[3].match(/(\/download.*)/)[1];
            page.appendItem(plugin.getDescriptor().id +':list:' + url, "directory", {
		title: new showtime.RichText(colorStr(match[1], orange) + ' ' +match[4] + coloredStr(end[2], green) + '/'+coloredStr(end[3], red) + colorStr(end[1], blue) +(comments ? colorStr(comments, orange) : '')),
		icon: licon
		});
           	page.entries++;
            match = re.exec(doc);
        }
    }


   
	function scraper(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
        var head= /::([\s\S]*?)<\/title[\s\S]*?<[\s\S]*?mail[\s\S]*?a href="([\s\S]*?)"[\s\S]*?/g;
	page.metadata.glwview = plugin.path + "list.view";

		var match1 = head.exec(doc);

		//Размер файла
		var razm = /<td class="header">Размер<\/td>([\s\S]*?)<\/td>/;
		var drzm = razm.exec(doc);
		var ndrzm = drzm[1].split(" ", 1);
		//

		// Описание
		var opsn = (/(Жанр|Категория)([\s\S]*?)<td class="header">Оценка</).exec(doc);
		var oppsk = (/(?:О фильме|Описание фильма|Описание|О сериале|Содержание|Сюжет фильма)(?:[\S\s]*?)([а-я])([\S\s]*?)</ig);
		var ngops = oppsk.exec(opsn);
		var ngops = ngops[1] + ngops[2];
		//

		//Постер
		var ogrr = /<table id="details">([\s\S]*?)(Жанр|Категория|Страна)/;   //Под вопросом???
	        var dltrim = ogrr.exec(doc);
		var obnn = dltrim[1] + dltrim[2] + dltrim[3];
		var mtrim = /(?:<img src=")([\s\S]*?)(?:")/g;
		var icons = plugin.path + "rutor.png";
		var tstru = /<a href="http:\/\/rutor([\s\S]*?)<img src/;
		var rezru = /([\s\S]*?)(?:<a href="http:\/\/rutor)([\s\S]*?)(?:<img src)([\s\S]*?)/;
		var rbnn = obnn;
		   if (tstru.test(obnn)) {
	      		 var rbnn = rezru.exec(obnn);
			 var rbnn = rbnn[1] + rbnn[2];
			}

		var bzvk = rbnn.match(mtrim);
		var fscr = bzvk.length;
		var pbzvk = bzvk[fscr-1].replace(/"/g, '').trim();
		var spbzvk = pbzvk.replace(/https/g, 'http').trim();
		var poster = spbzvk.replace(/<img src=/g, '').trim();
		//


		while (match1) {
                var url = service.baseURL + match1[2];
              if (match1[2].match(/http:\/\//))
                url = service.baseURL + match1[2].match(/(\/download.*)/)[1];
  
              page.appendItem('torrent:browse:' + url, "video", 
			{
			title: new showtime.RichText(coloredStr(match1[1], orange)),  
			description: ngops,
			icon: poster,
			genre: new showtime.RichText('<font size="6pt">  ' + coloredStr(ndrzm, blue) + '</font>')
			});
			
            page.entries++;
            match1 = head.exec(doc);
        }
		
	var re = /<tr class="[gai|tum]+"><td>([\s\S]*?)<\/td>[\s\S]*?href="([\s\S]*?)"[\s\S]*?<a href[\s\S]*?<a href="([\s\S]*?)">([\s\S]*?)<\/a>([\s\S]*?)<\/tr>/g;
        var match = re.exec(doc);
        while (match) {
            if (match[5].match(/alt="C"/)) {
                var end = match[5].match(/[\s\S]*?<td align="right">[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
                var comments = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)</)[1];
            } else
                var end = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
            var url = service.baseURL + match[3];
            if (match[3].match(/http:\/\//))
                url = match[3].match(/(\/download.*)/)[1];

            page.appendItem(plugin.getDescriptor().id +':list:' + url, "directory", 
			{
			title: new showtime.RichText(coloredStr(match[1], orange) + '  ' +match[4]),
			subtitle: new showtime.RichText('<font size="3px">  ' + coloredStr(end[1], blue) + '</font>' + '<font size="2pt">   ('+coloredStr(end[2], green)+'</font>' + '<font size="2pt">/'+'</font>'+'<font size="2pt">'+coloredStr(end[3], red)+')  </font>' + '<font size="2pt">' + (comments ? colorStr(comments, orange) : '')+'</font>'),
			icon: icons
			});
           	page.entries++;
            match = re.exec(doc);
        }
        
    }

	
	plugin.addURI(plugin.getDescriptor().id + ":category:(.*):(.*)", function(page, url,name) {
	        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var doc = showtime.httpReq(service.baseURL + url).toString();
		
        doc = doc.match(/<div id="index">([\s\S]*?)<!-- bottom banner -->/);
        if (doc) {
           var re = /<h2>([\s\S]*?)<tr class="backgr">([\s\S]*?)<\/table>/g;
           var match = re.exec(doc[1]);
           while (match) {
              page.appendItem("", "separator", {title: new showtime.RichText(match[1])});
               list(page, match[2]);
			   match = re.exec(doc[1]);
           }
        }; {list(page, doc)};
        page.loading = false;
    }); 

    plugin.addURI(plugin.getDescriptor().id + ":list:(.*)", function(page, url) {
        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var doc = showtime.httpReq(url).toString();
        scraper(page, doc); 
        page.loading = false;
    });


plugin.addURI(plugin.getDescriptor().id + ":start", function (page) {
	setPageHeader(page, plugin.getDescriptor().id.synopsis);
        page.appendItem(plugin.getDescriptor().id + ":search:", 'search', {
        title: 'Поиск на ' + service.baseURL
    });

	var arrow = plugin.path + "arrow.png";
	page.appendItem("", "separator", {title: ''});
        //Pages: browse, recent, tv shows, Music, Top 100
        var pages = [
                {
                    url: '/top',
                    name: 'Топ'
                },
                {
                    url: '/new',
                    name: 'Новые'
                },           
                {
                    url: '/kino',
                    name: 'Зарубежные фильмы'
                },	            
                {
                    url: '/nashe_kino',
                    name: 'Наши фильмы'
                },	            
                {
                    url: '/seriali',
                    name: 'Сериалы'
                },
                {
                    url: '/multiki',
                    name: 'Мультфильмы'
                },
                {
                    url: '/jumor',
                    name: 'Юмор'
                }
				
            ],
            i, length = pages.length;
        setPageHeader(page, plugin.getDescriptor().synopsis);
        for (i = 0; i < length; i++) 
		{
            
			page.appendItem(plugin.getDescriptor().id + ":category:" + pages[i].url + ':' + encodeURIComponent(pages[i].name), "directory", {
			 title: pages[i].name,
			 icon: arrow

			});
        
		}	
page.loading = false;			
    });

	
   function search(page, query) {
        setPageHeader(page, plugin.getDescriptor().title);
	page.entries = 0;
	var fromPage = 0, tryToSearch = true;
	
	function loader() {
            if (!tryToSearch) return false;
            page.loading = true;
	    var doc = showtime.httpReq(service.baseURL + "/search/"+ fromPage +"/0/000/0/" + query.replace(/\s/g, '\+')).toString();
	    page.loading = false;
            list(page, doc);
	    if (!doc.match(/downgif/)) return tryToSearch = false;
            fromPage++;
	    return true;
	};
	loader();
	page.paginator = loader;
   }

plugin.addURI(plugin.getDescriptor().id + ":search:(.*)", function(page, query) {
    search(page, query);
});

plugin.addSearcher(plugin.getDescriptor().id, logo, function(page, query) {
	setPageHeader(page, plugin.getDescriptor().title);
	page.entries = 0;
	var fromPage = 0, tryToSearch = true;
	
	function loader() {
            if (!tryToSearch) return false;
            page.loading = true;
	    var doc = showtime.httpReq(service.baseURL + "/search/"+ fromPage +"/0/000/0/" + query.replace(/\s/g, '\+')).toString();
	    page.loading = false;
            list(page, doc);
	    if (!doc.match(/downgif/)) return tryToSearch = false;
            fromPage++;
	    return true;
	};
	loader();
	page.paginator = loader;
      });

})(this);